## uzbl 0.0.0~git.20100105

=== Makefile ===
# first entries are for gnu make, 2nd for BSD make.  see http://lists.uzbl.org/pipermail/uzbl-dev-uzbl.org/2009-July/000177.html

CFLAGS:=-std=c99 $(shell pkg-config --cflags gtk+-2.0 webkit-1.0 libsoup-2.4 gthread-2.0) -ggdb -Wall -W -DARCH="\"$(shell uname -m)\"" -lgthread-2.0 -DCOMMIT="\"$(shell ./hash.sh)\"" $(CPPFLAGS) -fPIC -W -Wall -Wextra -pedantic
CFLAGS!=echo -std=c99 `pkg-config --cflags gtk+-2.0 webkit-1.0 libsoup-2.4 gthread-2.0` -ggdb -Wall -W -DARCH='"\""'`uname -m`'"\""' -lgthread-2.0 -DCOMMIT='"\""'`./hash.sh`'"\""' $(CPPFLAGS) -fPIC -W -Wall -Wextra -pedantic

LDFLAGS:=$(shell pkg-config --libs gtk+-2.0 webkit-1.0 libsoup-2.4 gthread-2.0) -pthread $(LDFLAGS)
LDFLAGS!=echo `pkg-config --libs gtk+-2.0 webkit-1.0 libsoup-2.4 gthread-2.0` -pthread $(LDFLAGS)

SRC = uzbl-core.c events.c callbacks.c inspector.c
OBJ = ${SRC:.c=.o}

all: uzbl-browser options

options:
	@echo
	@echo BUILD OPTIONS:
	@echo "CFLAGS   = ${CFLAGS}"
	@echo "LDFLAGS  = ${LDFLAGS}"
	@echo
	@echo See the README file for usage instructions.


.c.o:
	@echo COMPILING $<
	@${CC} -c ${CFLAGS} $<
	@echo ... done.

${OBJ}: uzbl-core.h events.h callbacks.h inspector.h config.h

uzbl-core: ${OBJ}
	@echo
	@echo LINKING object files
	@${CC} -o $@ ${OBJ} ${LDFLAGS}
	@echo ... done.
	@echo Stripping binary
	@strip $@
	@echo ... done.


uzbl-browser: uzbl-core

# packagers, set DESTDIR to your "package directory" and PREFIX to the prefix you want to have on the end-user system
# end-users who build from source: don't care about DESTDIR, update PREFIX if you want to
# RUN_PREFIX : what the prefix is when the software is run. usually the same as PREFIX
PREFIX?=/usr/local
INSTALLDIR?=$(DESTDIR)$(PREFIX)
RUN_PREFIX?=$(PREFIX)

# the 'tests' target can never be up to date
.PHONY: tests
force:

# When compiling unit tests, compile uzbl as a library first
tests: ${OBJ} force
	$(CC) -shared -Wl ${OBJ} -o ./tests/libuzbl-core.so
	cd ./tests/; $(MAKE)

test-uzbl-core: uzbl-core
	./uzbl-core --uri http://www.uzbl.org --verbose

test-uzbl-browser: uzbl-browser
	./uzbl-browser --uri http://www.uzbl.org --verbose

test-uzbl-core-sandbox: uzbl-core
	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-uzbl-core
	source ./sandbox/env.sh && uzbl-core --uri http://www.uzbl.org --verbose
	make DESTDIR=./sandbox uninstall
	rm -rf ./sandbox/usr

test-uzbl-browser-sandbox: uzbl-browser
	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-uzbl-browser
	source ./sandbox/env.sh && uzbl-cookie-daemon restart -nv &
	source ./sandbox/env.sh && uzbl-event-manager restart -nav &
	source ./sandbox/env.sh && uzbl-browser --uri http://www.uzbl.org --verbose
	source ./sandbox/env.sh && uzbl-cookie-daemon stop -v
	source ./sandbox/env.sh && uzbl-event-manager stop -v
	make DESTDIR=./sandbox uninstall
	rm -rf ./sandbox/usr

clean:
	rm -f uzbl-core
	rm -f uzbl-core.o
	rm -f events.o
	rm -f callbacks.o
	rm -f inspector.o
	find examples/ -name "*.pyc" -delete
	cd ./tests/; $(MAKE) clean
	rm -rf ./sandbox/{examples,usr}/

install: install-uzbl-core install-uzbl-browser install-uzbl-tabbed

install-uzbl-core: all
	install -d $(INSTALLDIR)/bin
	install -d $(INSTALLDIR)/share/uzbl/docs
	install -d $(INSTALLDIR)/share/uzbl/examples
	cp -rp docs     $(INSTALLDIR)/share/uzbl/
	cp -rp config.h $(INSTALLDIR)/share/uzbl/docs/
	cp -rp examples $(INSTALLDIR)/share/uzbl/
	install -m755 uzbl-core    $(INSTALLDIR)/bin/uzbl-core
	install -m644 AUTHORS      $(INSTALLDIR)/share/uzbl/docs
	install -m644 README       $(INSTALLDIR)/share/uzbl/docs
	sed -i 's#^set prefix.*=.*#set prefix     = $(RUN_PREFIX)#' $(INSTALLDIR)/share/uzbl/examples/config/uzbl/config

install-uzbl-browser: install-uzbl-core
	install -d $(INSTALLDIR)/bin
	install -m755 uzbl-browser $(INSTALLDIR)/bin/uzbl-browser
	install -m755 examples/data/uzbl/scripts/uzbl-cookie-daemon $(INSTALLDIR)/bin/uzbl-cookie-daemon
	install -m755 examples/data/uzbl/scripts/uzbl-event-manager $(INSTALLDIR)/bin/uzbl-event-manager
	sed -i 's#^PREFIX=.*#PREFIX=$(RUN_PREFIX)#' $(INSTALLDIR)/bin/uzbl-browser
	sed -i "s#^PREFIX = .*#PREFIX = '$(RUN_PREFIX)'#" $(INSTALLDIR)/bin/uzbl-event-manager

install-uzbl-tabbed: install-uzbl-browser
	install -d $(INSTALLDIR)/bin
	install -m755 examples/data/uzbl/scripts/uzbl-tabbed $(INSTALLDIR)/bin/uzbl-tabbed

uninstall:
	rm -rf $(INSTALLDIR)/bin/uzbl-*
	rm -rf $(INSTALLDIR)/share/uzbl

## uzbl 0.0.0~git.20100403

=== Makefile ===
# first entries are for gnu make, 2nd for BSD make.  see http://lists.uzbl.org/pipermail/uzbl-dev-uzbl.org/2009-July/000177.html

CFLAGS:=-std=c99 $(shell pkg-config --cflags gtk+-2.0 webkit-1.0 libsoup-2.4 gthread-2.0) -ggdb -Wall -W -DARCH="\"$(shell uname -m)\"" -lgthread-2.0 -DCOMMIT="\"$(shell ./misc/hash.sh)\"" $(CPPFLAGS) -fPIC -W -Wall -Wextra -pedantic
CFLAGS!=echo -std=c99 `pkg-config --cflags gtk+-2.0 webkit-1.0 libsoup-2.4 gthread-2.0` -ggdb -Wall -W -DARCH='"\""'`uname -m`'"\""' -lgthread-2.0 -DCOMMIT='"\""'`./misc/hash.sh`'"\""' $(CPPFLAGS) -fPIC -W -Wall -Wextra -pedantic

LDFLAGS:=$(shell pkg-config --libs gtk+-2.0 webkit-1.0 libsoup-2.4 gthread-2.0) -pthread $(LDFLAGS)
LDFLAGS!=echo `pkg-config --libs gtk+-2.0 webkit-1.0 libsoup-2.4 gthread-2.0` -pthread $(LDFLAGS)

SRC = $(wildcard src/*.c)
HEAD = $(wildcard src/*.h)
OBJ = $(foreach obj, $(SRC:.c=.o), $(notdir $(obj)))

all: uzbl-browser

VPATH:=src

.c.o:
	@echo -e "${CC} -c ${CFLAGS} $<"
	@${CC} -c ${CFLAGS} $<

${OBJ}: ${HEAD}

uzbl-core: ${OBJ}
	@echo -e "\n${CC} -o $@ ${OBJ} ${LDFLAGS}"
	@${CC} -o $@ ${OBJ} ${LDFLAGS}

uzbl-browser: uzbl-core

# packagers, set DESTDIR to your "package directory" and PREFIX to the prefix you want to have on the end-user system
# end-users who build from source: don't care about DESTDIR, update PREFIX if you want to
# RUN_PREFIX : what the prefix is when the software is run. usually the same as PREFIX
PREFIX?=/usr/local
INSTALLDIR?=$(DESTDIR)$(PREFIX)
DOCDIR?=$(INSTALLDIR)/share/uzbl/docs
RUN_PREFIX?=$(PREFIX)

# the 'tests' target can never be up to date
.PHONY: tests
force:

# When compiling unit tests, compile uzbl as a library first
tests: ${OBJ} force
	$(CC) -shared -Wl ${OBJ} -o ./tests/libuzbl-core.so
	cd ./tests/; $(MAKE)

test-uzbl-core: uzbl-core
	./uzbl-core --uri http://www.uzbl.org --verbose

test-uzbl-browser: uzbl-browser
	./src/uzbl-browser --uri http://www.uzbl.org --verbose

test-uzbl-core-sandbox: uzbl-core
	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-uzbl-core
	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-example-data
	cp -np ./misc/env.sh ./sandbox/env.sh
	source ./sandbox/env.sh && uzbl-core --uri http://www.uzbl.org --verbose
	make DESTDIR=./sandbox uninstall
	rm -rf ./sandbox/usr

test-uzbl-browser-sandbox: uzbl-browser
	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-uzbl-core
	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-uzbl-browser
	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-example-data
	cp -np ./misc/env.sh ./sandbox/env.sh
	source ./sandbox/env.sh && uzbl-cookie-daemon restart -nv &
	source ./sandbox/env.sh && uzbl-event-manager restart -nav &
	source ./sandbox/env.sh && uzbl-browser --uri http://www.uzbl.org --verbose
	source ./sandbox/env.sh && uzbl-cookie-daemon stop -v
	source ./sandbox/env.sh && uzbl-event-manager stop -v
	make DESTDIR=./sandbox uninstall
	rm -rf ./sandbox/usr

clean:
	rm -f uzbl-core
	rm -f uzbl-core.o
	rm -f events.o
	rm -f callbacks.o
	rm -f inspector.o
	find ./examples/ -name "*.pyc" -delete
	cd ./tests/; $(MAKE) clean
	rm -rf ./sandbox/

strip:
	@echo Stripping binary
	@strip uzbl-core
	@echo ... done.

install: install-uzbl-core install-uzbl-browser install-uzbl-tabbed

install-uzbl-core: all
	install -d $(INSTALLDIR)/share/uzbl/
	install -d $(DOCDIR)
	install -m644 docs/* $(DOCDIR)/
	install -m644 src/config.h $(DOCDIR)/
	install -m644 README $(DOCDIR)/
	install -m644 AUTHORS $(DOCDIR)/
	cp -r examples $(INSTALLDIR)/share/uzbl/
	chmod 755 $(INSTALLDIR)/share/uzbl/examples/data/scripts/*
	sed -i 's#^set prefix.*=.*#set prefix     = $(RUN_PREFIX)#' $(INSTALLDIR)/share/uzbl/examples/config/config
	install -D -m755 uzbl-core $(INSTALLDIR)/bin/uzbl-core

install-uzbl-browser:
	install -D -m755 src/uzbl-browser $(INSTALLDIR)/bin/uzbl-browser
	install -D -m755 examples/data/scripts/uzbl-cookie-daemon $(INSTALLDIR)/bin/uzbl-cookie-daemon
	install -D -m755 examples/data/scripts/uzbl-event-manager $(INSTALLDIR)/bin/uzbl-event-manager
	sed -i 's#^PREFIX=.*#PREFIX=$(RUN_PREFIX)#' $(INSTALLDIR)/bin/uzbl-browser
	sed -i "s#^PREFIX = .*#PREFIX = '$(RUN_PREFIX)'#" $(INSTALLDIR)/bin/uzbl-event-manager

install-uzbl-tabbed:
	install -D -m755 examples/data/scripts/uzbl-tabbed $(INSTALLDIR)/bin/uzbl-tabbed

# you probably only want to do this manually when testing and/or to the sandbox. not meant for distributors
install-example-data:
	install -d $(DESTDIR)/home/.config/uzbl
	install -d $(DESTDIR)/home/.cache/uzbl
	install -d $(DESTDIR)/home/.local/share/uzbl
	cp -rp examples/config/* $(DESTDIR)/home/.config/uzbl/
	cp -rp examples/data/*   $(DESTDIR)/home/.local/share/uzbl/

uninstall:
	rm -rf $(INSTALLDIR)/bin/uzbl-*
	rm -rf $(INSTALLDIR)/share/uzbl

=== tests/Makefile ===
CFLAGS:=-std=c99 -I$(shell pwd)/../ -L$(shell pwd) -luzbl-core $(shell pkg-config --cflags gtk+-2.0 webkit-1.0 libsoup-2.4 gthread-2.0) -ggdb -Wall -W -DARCH="\"$(shell uname -m)\"" -lgthread-2.0 -DG_ERRORCHECK_MUTEXES -DCOMMIT="\"$(shell git log | head -n1 | sed "s/.* //")\"" $(CPPFLAGS)
CFLAGS!=echo -std=c99 `pkg-config --cflags gtk+-2.0 webkit-1.0 libsoup-2.4 gthread-2.0` -ggdb -Wall -W -DARCH='"\""'`uname -m`'"\""' -lgthread-2.0 -DG_ERRORCHECK_MUTEXES -DCOMMIT='"\""'`git log | head -n1 | sed "s/.* //"`'"\""' $(CPPFLAGS)

LDFLAGS:=$(shell pkg-config --libs gtk+-2.0 webkit-1.0 libsoup-2.4 gthread-2.0) -pthread $(LDFLAGS)
LDFLAGS!=echo `pkg-config --libs gtk+-2.0 webkit-1.0 libsoup-2.4 gthread-2.0` -pthread $(LDFLAGS)

GTESTER:=gtester
GTESTER_REPORT:=gtester-report

TEST_PROGS:=test-expand test-command

all: $(TEST_PROGS)
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):." $(GTESTER) --verbose $(TEST_PROGS)

clean:
	rm -f $(TEST_PROGS)
	rm -f libuzbl-core.so

## uzbl 0.0.0~git.20110412

=== Makefile ===
# first entries are for gnu make, 2nd for BSD make.  see http://lists.uzbl.org/pipermail/uzbl-dev-uzbl.org/2009-July/000177.html

# packagers, set DESTDIR to your "package directory" and PREFIX to the prefix you want to have on the end-user system
# end-users who build from source: don't care about DESTDIR, update PREFIX if you want to
# RUN_PREFIX : what the prefix is when the software is run. usually the same as PREFIX
PREFIX?=/usr/local
INSTALLDIR?=$(DESTDIR)$(PREFIX)
DOCDIR?=$(INSTALLDIR)/share/uzbl/docs
RUN_PREFIX?=$(PREFIX)

# gtk2
REQ_PKGS += gtk+-2.0 webkit-1.0
CPPFLAGS =

# gtk3
#REQ_PKGS += gtk+-3.0 webkitgtk-3.0
#CPPFLAGS = -DG_DISABLE_DEPRECATED -DGTK_DISABLE_DEPRECATED

# --- configuration ends here ---

REQ_PKGS += libsoup-2.4 gthread-2.0 glib-2.0

ARCH:=$(shell uname -m)
ARCH!=echo `uname -m`

COMMIT_HASH:=$(shell ./misc/hash.sh)
COMMIT_HASH!=echo `./misc/hash.sh`

CPPFLAGS += -DARCH=\"$(ARCH)\" -DCOMMIT=\"$(COMMIT_HASH)\"

PKG_CFLAGS:=$(shell pkg-config --cflags $(REQ_PKGS))
PKG_CFLAGS!=echo pkg-config --cflags $(REQ_PKGS)

LDLIBS:=$(shell pkg-config --libs $(REQ_PKGS) x11)
LDLIBS!=echo pkg-config --libs $(REQ_PKGS) x11

CFLAGS += -std=c99 $(PKG_CFLAGS) -ggdb -W -Wall -Wextra -pedantic -pthread

SRC = $(wildcard src/*.c)
HEAD = $(wildcard src/*.h)
OBJ  = $(foreach obj, $(SRC:.c=.o),  $(notdir $(obj)))
LOBJ = $(foreach obj, $(SRC:.c=.lo), $(notdir $(obj)))

all: uzbl-browser

VPATH:=src

${OBJ}: ${HEAD}

uzbl-core: ${OBJ}

uzbl-browser: uzbl-core

# the 'tests' target can never be up to date
.PHONY: tests
force:

# this is here because the .so needs to be compiled with -fPIC on x86_64
${LOBJ}: ${SRC} ${HEAD}
	$(CC) $(CPPFLAGS) $(CFLAGS) -fPIC -c src/$(@:.lo=.c) -o $@

# When compiling unit tests, compile uzbl as a library first
tests: ${LOBJ} force
	$(CC) -shared -Wl ${LOBJ} -o ./tests/libuzbl-core.so
	cd ./tests/; $(MAKE)

test-uzbl-core: uzbl-core
	./uzbl-core --uri http://www.uzbl.org --verbose

test-uzbl-browser: uzbl-browser
	./bin/uzbl-browser --uri http://www.uzbl.org --verbose

test-uzbl-core-sandbox: uzbl-core
	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-uzbl-core
	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-example-data
	cp -np ./misc/env.sh ./sandbox/env.sh
	. ./sandbox/env.sh && uzbl-core --uri http://www.uzbl.org --verbose
	make DESTDIR=./sandbox uninstall
	rm -rf ./sandbox/usr

test-uzbl-browser-sandbox: uzbl-browser
	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-uzbl-core
	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-uzbl-browser
	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-example-data
	cp -np ./misc/env.sh ./sandbox/env.sh
	-. ./sandbox/env.sh && uzbl-event-manager restart -avv
	. ./sandbox/env.sh && uzbl-browser --uri http://www.uzbl.org --verbose
	. ./sandbox/env.sh && uzbl-event-manager stop -ivv
	make DESTDIR=./sandbox uninstall
	rm -rf ./sandbox/usr

test-uzbl-tabbed-sandbox: uzbl-browser
	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-uzbl-core
	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-uzbl-browser
	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-uzbl-tabbed
	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-example-data
	cp -np ./misc/env.sh ./sandbox/env.sh
	-. ./sandbox/env.sh && uzbl-event-manager restart -avv
	. ./sandbox/env.sh && uzbl-tabbed
	. ./sandbox/env.sh && uzbl-event-manager stop -ivv
	make DESTDIR=./sandbox uninstall
	rm -rf ./sandbox/usr

clean:
	rm -f uzbl-core
	rm -f uzbl-core.o
	rm -f events.o
	rm -f callbacks.o
	rm -f inspector.o
	rm -f cookie-jar.o
	rm -f util.o
	find ./examples/ -name "*.pyc" -delete
	cd ./tests/; $(MAKE) clean
	rm -rf ./sandbox/

strip:
	@echo Stripping binary
	@strip uzbl-core
	@echo ... done.

install: install-uzbl-core install-uzbl-browser install-uzbl-tabbed

install-dirs:
	[ -d "$(INSTALLDIR)/bin" ] || install -d -m755 $(INSTALLDIR)/bin

install-uzbl-core: all install-dirs
	install -d $(INSTALLDIR)/share/uzbl/
	install -d $(DOCDIR)
	install -m644 docs/* $(DOCDIR)/
	install -m644 src/config.h $(DOCDIR)/
	install -m644 README $(DOCDIR)/
	install -m644 AUTHORS $(DOCDIR)/
	cp -r examples $(INSTALLDIR)/share/uzbl/
	chmod 755 $(INSTALLDIR)/share/uzbl/examples/data/scripts/*
	install -m755 uzbl-core $(INSTALLDIR)/bin/uzbl-core

install-uzbl-browser: install-dirs
	install -m755 bin/uzbl-browser $(INSTALLDIR)/bin/uzbl-browser
	install -m755 bin/uzbl-event-manager $(INSTALLDIR)/bin/uzbl-event-manager
	mv $(INSTALLDIR)/bin/uzbl-browser $(INSTALLDIR)/bin/uzbl-browser.bak
	sed 's#^PREFIX=.*#PREFIX=$(RUN_PREFIX)#' < $(INSTALLDIR)/bin/uzbl-browser.bak > $(INSTALLDIR)/bin/uzbl-browser
	chmod 755 $(INSTALLDIR)/bin/uzbl-browser
	rm $(INSTALLDIR)/bin/uzbl-browser.bak
	mv $(INSTALLDIR)/bin/uzbl-event-manager $(INSTALLDIR)/bin/uzbl-event-manager.bak
	sed "s#^PREFIX = .*#PREFIX = '$(RUN_PREFIX)'#" < $(INSTALLDIR)/bin/uzbl-event-manager.bak > $(INSTALLDIR)/bin/uzbl-event-manager
	chmod 755 $(INSTALLDIR)/bin/uzbl-event-manager
	rm $(INSTALLDIR)/bin/uzbl-event-manager.bak

install-uzbl-tabbed: install-dirs
	install -m755 bin/uzbl-tabbed $(INSTALLDIR)/bin/uzbl-tabbed

# you probably only want to do this manually when testing and/or to the sandbox. not meant for distributors
install-example-data:
	install -d $(DESTDIR)/home/.config/uzbl
	install -d $(DESTDIR)/home/.cache/uzbl
	install -d $(DESTDIR)/home/.local/share/uzbl
	cp -rp examples/config/* $(DESTDIR)/home/.config/uzbl/
	cp -rp examples/data/*   $(DESTDIR)/home/.local/share/uzbl/

uninstall:
	rm -rf $(INSTALLDIR)/bin/uzbl-*
	rm -rf $(INSTALLDIR)/share/uzbl

=== tests/Makefile ===
# gtk2
REQ_PKGS += gtk+-2.0 webkit-1.0
CPPFLAGS = -I ../ -DERRORCHECK_MUTEXES

# gtk3
#REQ_PKGS += gtk+-3.0 webkitgtk-3.0
#CPPFLAGS = -I ../ -DERRORCHECK_MUTEXES -DG_DISABLE_DEPRECATED -DGTK_DISABLE_DEPRECATED

# --- configuration ends here ---

REQ_PKGS += libsoup-2.4 gthread-2.0 glib-2.0

ARCH:=$(shell uname -m)
ARCH!=echo `uname -m`

COMMIT_HASH:=$(shell cd .. && ./misc/hash.sh)
COMMIT_HASH!=echo `cd .. && ./misc/hash.sh`

CPPFLAGS += -DARCH=\"$(ARCH)\" -DCOMMIT=\"$(COMMIT_HASH)\"

PKG_CFLAGS:=$(shell pkg-config --cflags $(REQ_PKGS))
PKG_CFLAGS!=echo pkg-config --cflags $(REQ_PKGS)

LDLIBS:=$(shell pkg-config --libs $(REQ_PKGS) x11)
LDLIBS!=echo pkg-config --libs $(REQ_PKGS) x11

CFLAGS += -std=c99 $(PKG_CFLAGS) -ggdb -fPIC -W -Wall -Wextra -pedantic -pthread

GTESTER = gtester
GTESTER_REPORT = gtester-report

TEST_PROGS = test-expand test-command

all: $(TEST_PROGS)
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):." $(GTESTER) --verbose $(TEST_PROGS)

${TEST_PROGS}: libuzbl-core.so

clean:
	rm -f $(TEST_PROGS)
	rm -f libuzbl-core.so

## uzbl 0.0.0~git.20111001

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,3 @@
-# first entries are for gnu make, 2nd for BSD make.  see http://lists.uzbl.org/pipermail/uzbl-dev-uzbl.org/2009-July/000177.html
-
 # packagers, set DESTDIR to your "package directory" and PREFIX to the prefix you want to have on the end-user system
 # end-users who build from source: don't care about DESTDIR, update PREFIX if you want to
 # RUN_PREFIX : what the prefix is when the software is run. usually the same as PREFIX
@@ -8,31 +6,30 @@
 DOCDIR?=$(INSTALLDIR)/share/uzbl/docs
 RUN_PREFIX?=$(PREFIX)
 
-# gtk2
-REQ_PKGS += gtk+-2.0 webkit-1.0
-CPPFLAGS =
+# use GTK3-based webkit when it is available
+USE_GTK3 = $(shell pkg-config --exists gtk+-3.0 webkitgtk-3.0 && echo 1)
 
-# gtk3
-#REQ_PKGS += gtk+-3.0 webkitgtk-3.0
-#CPPFLAGS = -DG_DISABLE_DEPRECATED -DGTK_DISABLE_DEPRECATED
+ifeq ($(USE_GTK3),1)
+	REQ_PKGS += gtk+-3.0 webkitgtk-3.0
+	CPPFLAGS = -DG_DISABLE_DEPRECATED -DGTK_DISABLE_DEPRECATED
+else
+	REQ_PKGS += gtk+-2.0 webkit-1.0
+	CPPFLAGS =
+endif
 
 # --- configuration ends here ---
 
 REQ_PKGS += libsoup-2.4 gthread-2.0 glib-2.0
 
 ARCH:=$(shell uname -m)
-ARCH!=echo `uname -m`
 
 COMMIT_HASH:=$(shell ./misc/hash.sh)
-COMMIT_HASH!=echo `./misc/hash.sh`
 
 CPPFLAGS += -DARCH=\"$(ARCH)\" -DCOMMIT=\"$(COMMIT_HASH)\"
 
 PKG_CFLAGS:=$(shell pkg-config --cflags $(REQ_PKGS))
-PKG_CFLAGS!=echo pkg-config --cflags $(REQ_PKGS)
 
 LDLIBS:=$(shell pkg-config --libs $(REQ_PKGS) x11)
-LDLIBS!=echo pkg-config --libs $(REQ_PKGS) x11
 
 CFLAGS += -std=c99 $(PKG_CFLAGS) -ggdb -W -Wall -Wextra -pedantic -pthread
 
@@ -79,7 +76,6 @@
 	rm -rf ./sandbox/usr
 
 test-uzbl-browser-sandbox: uzbl-browser
-	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-uzbl-core
 	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-uzbl-browser
 	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-example-data
 	cp -np ./misc/env.sh ./sandbox/env.sh
@@ -90,7 +86,6 @@
 	rm -rf ./sandbox/usr
 
 test-uzbl-tabbed-sandbox: uzbl-browser
-	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-uzbl-core
 	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-uzbl-browser
 	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-uzbl-tabbed
 	make DESTDIR=./sandbox RUN_PREFIX=`pwd`/sandbox/usr/local install-example-data
@@ -103,12 +98,7 @@
 
 clean:
 	rm -f uzbl-core
-	rm -f uzbl-core.o
-	rm -f events.o
-	rm -f callbacks.o
-	rm -f inspector.o
-	rm -f cookie-jar.o
-	rm -f util.o
+	rm -f *.o
 	find ./examples/ -name "*.pyc" -delete
 	cd ./tests/; $(MAKE) clean
 	rm -rf ./sandbox/
@@ -130,21 +120,17 @@
 	install -m644 src/config.h $(DOCDIR)/
 	install -m644 README $(DOCDIR)/
 	install -m644 AUTHORS $(DOCDIR)/
+	install -m755 uzbl-core $(INSTALLDIR)/bin/uzbl-core
+
+install-event-manager: install-dirs
+	sed "s#^PREFIX = .*#PREFIX = '$(RUN_PREFIX)'#" < bin/uzbl-event-manager > $(INSTALLDIR)/bin/uzbl-event-manager
+	chmod 755 $(INSTALLDIR)/bin/uzbl-event-manager
+
+install-uzbl-browser: install-dirs install-uzbl-core install-event-manager
+	sed 's#^PREFIX=.*#PREFIX=$(RUN_PREFIX)#' < bin/uzbl-browser > $(INSTALLDIR)/bin/uzbl-browser
+	chmod 755 $(INSTALLDIR)/bin/uzbl-browser
 	cp -r examples $(INSTALLDIR)/share/uzbl/
 	chmod 755 $(INSTALLDIR)/share/uzbl/examples/data/scripts/*
-	install -m755 uzbl-core $(INSTALLDIR)/bin/uzbl-core
-
-install-uzbl-browser: install-dirs
-	install -m755 bin/uzbl-browser $(INSTALLDIR)/bin/uzbl-browser
-	install -m755 bin/uzbl-event-manager $(INSTALLDIR)/bin/uzbl-event-manager
-	mv $(INSTALLDIR)/bin/uzbl-browser $(INSTALLDIR)/bin/uzbl-browser.bak
-	sed 's#^PREFIX=.*#PREFIX=$(RUN_PREFIX)#' < $(INSTALLDIR)/bin/uzbl-browser.bak > $(INSTALLDIR)/bin/uzbl-browser
-	chmod 755 $(INSTALLDIR)/bin/uzbl-browser
-	rm $(INSTALLDIR)/bin/uzbl-browser.bak
-	mv $(INSTALLDIR)/bin/uzbl-event-manager $(INSTALLDIR)/bin/uzbl-event-manager.bak
-	sed "s#^PREFIX = .*#PREFIX = '$(RUN_PREFIX)'#" < $(INSTALLDIR)/bin/uzbl-event-manager.bak > $(INSTALLDIR)/bin/uzbl-event-manager
-	chmod 755 $(INSTALLDIR)/bin/uzbl-event-manager
-	rm $(INSTALLDIR)/bin/uzbl-event-manager.bak
 
 install-uzbl-tabbed: install-dirs
 	install -m755 bin/uzbl-tabbed $(INSTALLDIR)/bin/uzbl-tabbed

## uzbl 0.0.0~git.20111128

=== Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 USE_GTK3 = $(shell pkg-config --exists gtk+-3.0 webkitgtk-3.0 && echo 1)
 
 ifeq ($(USE_GTK3),1)
-	REQ_PKGS += gtk+-3.0 webkitgtk-3.0
+	REQ_PKGS += gtk+-3.0 webkitgtk-3.0 javascriptcoregtk-3.0
 	CPPFLAGS = -DG_DISABLE_DEPRECATED -DGTK_DISABLE_DEPRECATED
 else
 	REQ_PKGS += gtk+-2.0 webkit-1.0

## uzbl 0.0.0~git.20120514

=== Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 	REQ_PKGS += gtk+-3.0 webkitgtk-3.0 javascriptcoregtk-3.0
 	CPPFLAGS = -DG_DISABLE_DEPRECATED -DGTK_DISABLE_DEPRECATED
 else
-	REQ_PKGS += gtk+-2.0 webkit-1.0
+	REQ_PKGS += gtk+-2.0 webkit-1.0 javascriptcoregtk-1.0
 	CPPFLAGS =
 endif
 
@@ -25,7 +25,7 @@
 
 COMMIT_HASH:=$(shell ./misc/hash.sh)
 
-CPPFLAGS += -DARCH=\"$(ARCH)\" -DCOMMIT=\"$(COMMIT_HASH)\"
+CPPFLAGS += -D_BSD_SOURCE -D_POSIX_SOURCE -DARCH=\"$(ARCH)\" -DCOMMIT=\"$(COMMIT_HASH)\"
 
 PKG_CFLAGS:=$(shell pkg-config --cflags $(REQ_PKGS))

=== tests/Makefile ===
--- 
+++ 
@@ -1,12 +1,15 @@
-# gtk2
-REQ_PKGS += gtk+-2.0 webkit-1.0
 CPPFLAGS = -I ../ -DERRORCHECK_MUTEXES
 
-# gtk3
-#REQ_PKGS += gtk+-3.0 webkitgtk-3.0
-#CPPFLAGS = -I ../ -DERRORCHECK_MUTEXES -DG_DISABLE_DEPRECATED -DGTK_DISABLE_DEPRECATED
+# use GTK3-based webkit when it is available
+USE_GTK3 = $(shell pkg-config --exists gtk+-3.0 webkitgtk-3.0 && echo 1)
 
-# --- configuration ends here ---
+ifeq ($(USE_GTK3),1)
+	REQ_PKGS += gtk+-3.0 webkitgtk-3.0
+	CPPFLAGS += -DG_DISABLE_DEPRECATED -DGTK_DISABLE_DEPRECATED
+else
+	REQ_PKGS += gtk+-2.0 webkit-1.0
+	CPPFLAGS +=
+endif
 
 REQ_PKGS += libsoup-2.4 gthread-2.0 glib-2.0

=== debian/changelog ===
uzbl (0.0.0~git.20120514-1.2) unstable; urgency=medium

  * Non-maintainer upload with maintainer approval.
  * run wrap-and-sort.
  * debian/control:
    + use canonical urls for Vcs-* fields.
    + bump Standards-Version: no changes needed.
    + add build-dep on python-all-dev.
  * debian/rules:
    + correct use of echo.
    + enable hardening.
    + let dh_auto_install do its magic by just adding two options instead of
      overriding everything.
    + move to dh short format, and compat level 9. enable parallel building.
    + fix the perms in a override_dh_fixperms instad of in override_dh_install,
      also drop a now useless chmod.
  * convert packing to format 3.0 (quilt) from 1.0.
  * use dh-python2 instead of pysupport.  Closes: #786021
  * remove d/README.source, this package is standard 3.0 (quilt), nothing more.
  * debian/copyright: fix typo.
  * debian/patch/revert-python2.patch: add dep3 header.
  * install that desktop file.  Closes: #772591
  * debian/uzbl.desktop: remove the Encoding keyword, it's now deprecated.
  * remove the menu file after the last ctte decision.

 -- Mattia Rizzolo <mattia@mapreri.org>  Thu, 12 Nov 2015 15:05:10 +0000

uzbl (0.0.0~git.20120514-1.1) unstable; urgency=low

  * Non-maintainer upload with maintainer approval.
  * Preserve x-www-browser alternative on upgrades.
  * Remove x-www-browser alternative on uninstallation.  (Closes: #656222)

 -- Andreas Beckmann <anbe@debian.org>  Mon, 28 Jan 2013 22:41:20 +0100

uzbl (0.0.0~git.20120514-1) unstable; urgency=low

  * New upstream version

 -- Luca Bruno <lucab@debian.org>  Sat, 19 May 2012 09:27:00 +0200

uzbl (0.0.0~git.20111128-2) unstable; urgency=high

  * Security fix for CVE-2012-0843
    + Restrict third-party access to cookie jar (Closes: #659379) 

 -- Luca Bruno <lucab@debian.org>  Tue, 14 Feb 2012 18:14:55 +0100

uzbl (0.0.0~git.20111128-1) unstable; urgency=low

  * New upstream version

 -- Luca Bruno <lucab@debian.org>  Thu, 08 Dec 2011 18:46:55 +0100

uzbl (0.0.0~git.20111001-1) unstable; urgency=low

  * New upstream version

 -- Luca Bruno <lucab@debian.org>  Sat, 26 Nov 2011 11:28:14 +0100

uzbl (0.0.0~git.20110412-2) unstable; urgency=low

  * Moving suggested packages to Recommends (Closes: #626815, #626818)
  * Increase required python version to 2.6, for plugins (Closes: #642491)
  * Update build-dep for libwebkitgtk renaming (Closes: #635429, #646475)

 -- Luca Bruno <lucab@debian.org>  Mon, 07 Nov 2011 13:42:21 +0100

uzbl (0.0.0~git.20110412-1) unstable; urgency=low

  [ Francesca Ciceri ]
  * Added suckless-tools as alternative to dwm-tools on Suggests field

  [ Luca Bruno ]
  * New Upstream version
  * Removed Stefan from maintainers list (Closes: #607325)

 -- Luca Bruno <lucab@debian.org>  Wed, 13 Apr 2011 11:58:50 +0200

uzbl (0.0.0~git.20110317-1) unstable; urgency=low

  * New upstream relese
    + Fixed broken uzbl-tabbed (Closes: #618919, #618626)

 -- Luca Bruno <lucab@debian.org>  Mon, 21 Mar 2011 11:56:56 +0100

uzbl (0.0.0~git.20110314-1) unstable; urgency=low

  * Bumped libwebkit-dev dependency to avoid segfault on kfreebsd-i386
    (Closes: #559489)
  * Fix FTBFS with gold or ld --no-add-needed (Closes: #615790)
  * New upstream release 
    + Fixed "Open in new window" context menu (Closes: #606669)
    + Breaks backward compatibility, please read NEWS.Debian

 -- Luca Bruno <lucab@debian.org>  Wed, 16 Mar 2011 16:48:25 +0100

uzbl (0.0.0~git.20100403-3) unstable; urgency=high

  * Fix unsafe URI handling in default config, which may lead to arbitrary 
    command execution, CVE-2010-2809 (Closes: #594301)
  * Added NEWS.Debian suggesting how to fix user customized config in home
    directory

 -- Luca Bruno <lucab@debian.org>  Fri, 27 Aug 2010 16:26:30 +0200

uzbl (0.0.0~git.20100403-2) unstable; urgency=low

  [ Stefan Ritter ]
  * Fix lintian warning (executable-not-elf-or-script)
  * Add source format (1.0)

  [ Luca Bruno ]
  * Add patch to fix bashisms (Closes: #581145, #577716, #579115)

 -- Luca Bruno <lucab@debian.org>  Sat, 15 May 2010 22:00:14 +0200

uzbl (0.0.0~git.20100403-1) unstable; urgency=low

  [ Luca Bruno ]
  * Fix wrong statement in uzbl manpage regarding config from stdin

  [ Clint Adams ]
  * New upstream version.  closes: #576897.
    - Drop fix-install patch and set DOCDIR instead.

 -- Clint Adams <schizo@debian.org>  Thu, 08 Apr 2010 10:26:02 -0400

uzbl (0.0.0~git.20100314-1) unstable; urgency=low

  * New upstream version

 -- Luca Bruno <lucab@debian.org>  Sat, 20 Mar 2010 20:34:09 +0100

uzbl (0.0.0~git.20100202-1) unstable; urgency=low

  [ Luca Bruno ]
  * New upstream version, git-tag 2010.02.02 (Closes: #572159)
    + uzbl-tabbed and linkfollowing should be working again, with newer
      default config
  * Refreshed patches, dropping those already fixed upstream
  * Updated Standards-Version to 3.8.4

  [ Stefan Ritter ]
  * Added manpages for uzbl-cookie-daemon and uzbl-event-manager
  * Added alternative for x-www-browser, now providing www-browser too
    (Closes: #564067)

 -- Luca Bruno <lucab@debian.org>  Sat, 06 Mar 2010 15:07:00 +0100

uzbl (0.0.0~git.20100105-1) unstable; urgency=high

  * New upstream version, git-tag 2010.01.05
    + security release, disable global Uzbl JS object; this may break
      external scripts depending on it (CVE-2010-0011)

 -- Luca Bruno <lucab@debian.org>  Wed, 06 Jan 2010 22:42:34 +0100

uzbl (0.0.0~git.20091222-1) unstable; urgency=low

  * New upstream version, git-tag 2009.12.22

 -- Luca Bruno <lucab@debian.org>  Thu, 24 Dec 2009 17:41:34 +0100

uzbl (0.0.0~git.20091130-2) unstable; urgency=low

  * Added python-gtk2 and python-gobject as dependencies since uzbl-tabbed
    needs them (Closes: #559336)
  * Added xclip and python-simplejson to suggests (Closes: #559337)

 -- Stefan Ritter <xeno@thehappy.de>  Fri, 18 Dec 2009 10:20:00 +0200

uzbl (0.0.0~git.20091130-1) unstable; urgency=low

  [ Stefan Ritter ]
  * Added symlinks for missing manpages


=== debian/control ===
Source: uzbl
Section: web
Priority: extra
Maintainer: Luca Bruno <lucab@debian.org>
Homepage: http://www.uzbl.org/
Build-Depends: debhelper (>= 9),
               dh-python,
               libgtk2.0-dev (>= 2.14),
               libsoup2.4-dev (>= 2.24),
               libwebkitgtk-dev (>= 1.2.5-2.1),
               pkg-config,
               python-all-dev
Vcs-Git: git://anonscm.debian.org/collab-maint/uzbl.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/uzbl.git
Standards-Version: 3.9.6
X-Python-Version: >= 2.6

Package: uzbl
Architecture: any
Depends: python-gobject,
         python-gtk2,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Provides: www-browser
Recommends: dwm-tools | suckless-tools,
            python-simplejson,
            socat,
            xclip,
            zenity
Description: Lightweight Webkit browser following the UNIX philosophy
 Uzbl follows the UNIX philosophy - "Write programs that do one thing and do it
 well. Write programs to work together. Write programs to handle text streams,
 because that is a universal interface."
 .
  * very minimal graphical interface. You only see what you need
  * what is not browsing, is not in uzbl. Things like url changing,
    loading/saving of bookmarks, saving history, downloads, ... are handled
    through external scripts that you write
  * controllable through various means such as fifo and socket files, stdin,
    keyboard and more
  * advanced, customizable keyboard interface with support for modes, modkeys,
    multichars, variables (keywords) etc. (eg you can tweak the interface to be
    vim-like, emacs-like or any-other-program-like)
  * focus on plaintext storage for your data and configs in simple, parseable
    formats
  * Uzbl keeps it simple, and puts _you_ in charge.

=== debian/rules ===
#!/usr/bin/make -f

export LIBS+='-lX11'
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --parallel --with python2

override_dh_auto_test:
	@echo "Skipping tests..."

override_dh_compress:
	dh_compress -XCONTRIBUTING -XFAQ -XREADME -XTODO -Xconfig \
		    -Xcookies.sh -X.js -X.py

override_dh_auto_install:
	dh_auto_install -- PREFIX="/usr" DOCDIR='$${DESTDIR}/usr/share/doc/uzbl'
	rm -f $(CURDIR)/debian/uzbl/usr/share/doc/uzbl/INSTALL

override_dh_fixperms:
	dh_fixperms
	chmod 0755 $(CURDIR)/debian/uzbl/usr/share/uzbl/examples/data/scripts/util/*.sh

=== debian/watch ===
version=3

opts=dversionmangle=s/(\d+\.*){3}~git\.//,uversionmangle=s/\.//g \
 http://githubredir.debian.net/github/Dieterbe/uzbl/(\d.*)\.tar\.gz
